#
# missing/rdblockparser.tab.rb: generated by racc (runtime embedded)
#

###### racc/parser.rb

unless $".index 'racc/parser.rb.rb' then
$".push 'racc/parser.rb.rb'
#
# parser.rb
#
#   Copyright (c) 1999,2000 Minero Aoki <aamine@dp.u-netsurf.ne.jp>
#
#   This program is free software.
#   You can distribute/modify this program under the terms of
#   the GNU Lesser General Public License version 2 or later.
#
#   As a special exception, when this code is copied by Racc
#   into a Racc output file, you may use that output file
#   without restriction.
#

unless defined? ParseError then
  class ParseError < StandardError; end
end


module Racc


class Parser

  private


  begin
    require 'racc/cparse'   # def _c_parse
    Racc_Main_Parsing_Routine = :_c_parse
  rescue LoadError
    Racc_Main_Parsing_Routine = :_rb_parse
  end


  def next_token
    raise NotImplementError, "#{self.type}#next_token must be defined"
  end


  def do_parse
    t = self.type
    unless t::Racc_debug_parser then
      @yydebug = false
    end
    @yydebug = @yydebug ? true : false
    if @yydebug then
      @racc_debug_out ||= $stderr
    end

    send Racc_Main_Parsing_Routine, t::Racc_arg, false
  end


  def _rb_parse( arg, in_debug )
    action_table, action_check, action_default, action_pointer,
    goto_table, goto_check, goto_default, goto_pointer,
    nt_base, reduce_table, token_table, shift_n, reduce_n = *arg

    #
    # local variables
    #

    state    = [ 0 ]
    curstate = 0

    tstack = []
    vstack = []

    atmp = tok = val = t = nil
    act = tmp = code = i = nil
    read_next = true

    @racc_error_status = 0
    nerr = 0
    user_yyerror = false

    t_end = 0    # $end
    t_err = 1    # error token

    yydebug = @yydebug

    #
    # LR parsing algorithm main loop
    #

    while true do

      if i = action_pointer[ curstate ] then
        if read_next then
          if t != t_end then
            atmp = next_token
            tok = atmp[0]
            val = atmp[1]
            t = (token_table[tok] or t_err)
            racc_read_token( t, tok, val ) if yydebug

            read_next = false
          end
        end
        i += t
        if i >= 0 and act = action_table[i] and
           action_check[i] == curstate then
        else
          act = action_default[ curstate ]
        end
      else
        act = action_default[ curstate ]
      end

  begin
      if act > 0 and act < shift_n then
        #
        # shift
        #

        if @racc_error_status > 0 then
          @racc_error_status -= 1
        end

        vstack.push val
        if yydebug then
          tstack.push t
          racc_shift( t, tstack, vstack )
        end

        curstate = act
        state.push curstate

        read_next = true

      elsif act < 0 and act > -reduce_n then
        #
        # reduce
        #

        code = catch( :racc_jump ) {
          curstate = racc_do_reduce( arg, state, vstack, tstack, act )
          state.push curstate; false
        }
        if code then
          case code
          when 1 # yyerror
            act = -reduce_n
            user_yyerror = true
            redo
          when 2 # yyaccept
            act = shift_n
            redo
          else
            raise RuntimeError, '[Racc Bug] unknown jump code'
          end
        end

      elsif act == shift_n then
        #
        # accept
        #

        racc_accept if yydebug
        return vstack[0]

      elsif act == -reduce_n then
        #
        # error
        #

        case @racc_error_status
        when 0
          unless user_yyerror then
            nerr += 1
            on_error( t, val, vstack )
          end
        when 3
          if t == t_end then
            return nil
          end
          read_next = true
        end
        user_yyerror = false
        @racc_error_status = 3

        while true do
          if i = action_pointer[curstate] then
            i += t_err
            if i >= 0 and
               (act = action_table[i]) and
               action_check[i] == curstate then
              break
            end
          end

          return nil if state.size < 2
          state.pop
          vstack.pop
          if yydebug then
            tstack.pop
            racc_e_pop( state, tstack, vstack )
          end
          curstate = state[-1]
        end

        if act > 0 and act < shift_n then
          #
          # error-shift
          #
          vstack.push val
          if yydebug then
            tstack.push t_err
            racc_shift( t_err, tstack, vstack )
          end

          curstate = act
          state.push curstate
          
        elsif act < 0 and act > -reduce_n then
          #
          # error-reduce
          #
          code = catch( :racc_jump ) {
            curstate = racc_do_reduce( arg, state, vstack, tstack, act )
            state.push curstate; 0
          }
          unless code == 0 then
            case code
            when 1 # yyerror
              act = -reduce_n
              user_yyerror = true
              redo
            when 2 # yyaccept
              act = shift_n
              redo
            else
              raise RuntimeError, '[Racc Bug] unknown jump code'
            end
          end

        elsif act == shift_n then
          #
          # error-accept
          #
          racc_accept if yydebug
          return vstack[0]

        else
          raise RuntimeError, "[Racc Bug] wrong act value #{act.inspect}"
        end

      else
        raise RuntimeError, "[Racc Bug] unknown action #{act.inspect}"
      end
  end while false

      racc_next_state( curstate, state ) if yydebug
    end

    raise RuntimeError, '[Racc Bug] must not reach here'
  end


  def on_error( t, val, vstack )
    raise ParseError, "\nunexpected token #{val.inspect}"
  end


  def racc_do_reduce( arg, state, vstack, tstack, act )
    action_table, action_check, action_default, action_pointer,
    goto_table, goto_check, goto_default, goto_pointer,
    nt_base, reduce_table, token_table, shift_n, reduce_n = *arg

    i = act * -3
    len       = reduce_table[i]
    reduce_to = reduce_table[i+1]
    method_id = reduce_table[i+2]
    void_array = []

    tmp_t = tstack[ -len, len ] if @yydebug
    tmp_v = vstack[ -len, len ]
    tstack[ -len, len ] = void_array if @yydebug
    vstack[ -len, len ] = void_array
    state[ -len, len ]  = void_array

    # tstack must be renewed AFTER method call
    vstack.push( (method_id == :_reduce_none) ?
                     tmp_v[0] : send(method_id, tmp_v, vstack, tmp_v[0]) )
    tstack.push reduce_to

    racc_reduce( tmp_t, reduce_to, tstack, vstack ) if @yydebug

    k1 = reduce_to - nt_base
    if i = goto_pointer[ k1 ] then
      i += state[-1]
      if i >= 0 and (curstate = goto_table[i]) and goto_check[i] == k1 then
        return curstate
      end
    end
    goto_default[ k1 ]
  end

  def yyerror
    throw :racc_jump, 1
  end

  def yyaccept
    throw :racc_jump, 2
  end

  def yyerrok
    @racc_error_status = 0
  end


  # for debugging output

  def racc_read_token( t, tok, val )
    @racc_debug_out.print 'read    '
    @racc_debug_out.print tok.inspect, '(internaly ', racc_token2str(t), ') '
    @racc_debug_out.puts val.inspect
    @racc_debug_out.puts
  end

  def racc_shift( tok, tstack, vstack )
    @racc_debug_out.puts "shift   #{racc_token2str tok}"
    racc_print_stacks tstack, vstack
    @racc_debug_out.puts
  end

  def racc_reduce( toks, sim, tstack, vstack )
    out = @racc_debug_out
    out.print 'reduce '
    if toks.empty? then
      out.print ' <none>'
    else
      toks.each {|t| out.print ' ', racc_token2str(t) }
    end
    out.puts " --> #{racc_token2str(sim)}"
        
    racc_print_stacks tstack, vstack
    @racc_debug_out.puts
  end

  def racc_accept
    @racc_debug_out.puts 'accept'
    @racc_debug_out.puts
  end

  def racc_e_pop( state, tstack, vstack )
    @racc_debug_out.puts 'error recovering mode: pop token'
    racc_print_states state
    racc_print_stacks tstack, vstack
    @racc_debug_out.puts
  end

  def racc_next_state( curstate, state )
    @racc_debug_out.puts  "goto    #{curstate}"
    racc_print_states state
    @racc_debug_out.puts
  end

  def racc_print_stacks( t, v )
    out = @racc_debug_out
    out.print '        ['
    t.each_index do |i|
      out.print ' (', racc_token2str(t[i]), ' ', v[i].inspect, ')'
    end
    out.puts ' ]'
  end

  def racc_print_states( s )
    out = @racc_debug_out
    out.print '        ['
    s.each {|st| out.print ' ', st }
    out.puts ' ]'
  end

  def racc_token2str( tok )
    type::Racc_token_to_s_table[tok] or
      raise RuntimeError, "[Racc Bug] can't convert token #{tok} to string"
  end

end


end   # module Racc
end   # end of racc/parser.rb

require "rd/rdinlineparser.tab.rb"

=begin
= rdblockparser.ry
== What is rdblockparser.ry
RDtool parse RD with two kinds of parser. One is for Block level parsing,
and another is for Inline level parsing. rdblockparser.ry is Racc syntax
definition for Block level parser.

== Block level and Inline level
In Block level, RD's syntax widely uses indent. So RDtool devides parsing
process into two levels to simplify syntax and lexical analizing. 
Class RDBlockParser in rdblockparser.ry is to do this Block level parsing
process, and Class RDInlineParser in rdinlineparser.ry do Inline level
one. A instance of RDBlockParser has a instance of RDInlineParser.
RDBlockParser parse RD with help of RDInlineParser. 

== Block level Parsing
Please read BNF of syntax definition in rdblockparser.ry.

== Block level lexical analizing
Now Racc needs only ((*one*)) method, (({next_token})) for lexical analyzing.
So, (({tokenize})) is into (({next_token})), and (({@rylval})) has desappeared.

Lexer regards Each line as token, (({STRINGLINE})), (({WHITELINE})),
(({BLANKLINE})) or (({HEADLINE})). But lexer also see how indent line
is and if line starts with some special character, for example 
(({LISTMARK}))s.

Lexer manages indent with a stack, "(({@indent_stack}))". 
(({@indent_stack})) have the current state of indent. So lexer know
current baseline, that is as deep as 
(({currentIndent = @indent_stack.join("")})). When indent of current line
is deeper than baseline, lexer push diff of indent of current line
and baseline into (({@indent_stack})) and return INDENT to parser.
And when indent of current line is sharrower than baseline, lexer
do (({@index_stack.pop})) and return DEDENT.
=end
=begin
== script info.
 parser for RD Blocks.
 $Id: rdblockparser.ry,v 1.31 2000/06/24 17:06:51 toshirok Exp $

=end

module RD
class RDParser < Racc::Parser

=begin
  --- RDParser.new()
        initializer.
=end

def initialize
  @inline_parser = RDInlineParser.new(self)
end

=begin
  --- RDParser#parse(src, tree)
        start to parse. ((|src|)) is RD source. ((|tree|)) is (({RDTree}))
        which will contain parsed syntax tree.
=end

def parse(src, tree)
  @src = src
  @src.push(false)
  # RDtree
  @tree = tree
  
  # @i: index(line no.) of src
  @i = 0
  # stack for current indentation
  @indent_stack = []
  # how indented.
  @current_indent = @indent_stack.join("")
  # RDParser for tmp src
  @subparser = nil
  # which part is in now
  @in_part = nil
  @part_content = []
  @tmpfile_num = 0
  
  # swap_line status var.(for error message)
  @swaped_line = ""
  @is_swaped

  @yydebug = true
  do_parse
end

=begin
  --- RDParser#next_token()
        return next token. this method is called from Racc iternal.
=end

def next_token
  @is_swaped = false
  # preprocessing
  # if it is not in RD part
  # => method
  while @in_part != "rd"
    line = @src[@i]
    @i += 1 # next line
    
    case line
    # src end
    when false
      return [false, false]
    # RD part begin
    when /^=begin\s*(?:\bRD\b.*)?\s*$/
      if @in_part # if in non-RD part
	@part_content.push(line)
      else
	@in_part = "rd"
	return [:WHITELINE, "=begin\n"] # <= for textblockand
      end
    # non-RD part begin
    when /^=begin\s+(\w+)/
      part = $1
      if @in_part # if in non-RD part
	@part_content.push(line)
      else
	@in_part = part if @tree.filter[part] # if filter exists
#	p "BEGIN_PART: #{@in_part}" # DEBUG
      end
    # non-RD part end
    when /^=end/
      if @in_part # if in non-RD part
#	p "END_PART: #{@in_part}" # DEBUG
	# make Part-in object
	part = RD::Part.new(@part_content.join(""), @tree, "r")
	@part_content.clear
	# call filter, part_out is output(Part object)
	part_out = @tree.filter[@in_part].call(part)
	
	if @tree.filter[@in_part].mode == :rd # if output is RD formated
	  subtree = parse_subtree(part_out.to_a)
	else # if output is target formated
	  basename = "rdtmp.#{$$}.#{@tmpfile_num}"
	  @tmpfile_num += 1
	  tmpfile = open(@tree.tmp_dir + "/" + basename + ".#{@in_part}", "w")
	  tmpfile.print(part_out)
	  tmpfile.close
	  subtree = parse_subtree(["=begin\n", "<<< #{basename}\n", "=end\n"])
	end
	@in_part = nil
	return [:SUBTREE, subtree]
      end
    else
      if @in_part # if in non-RD part
	@part_content.push(line)
      end
    end
  end

  @current_indent = @indent_stack.join("")
  line = @src[@i]
  case line
  when false
    if_current_indent_equal("") do
      [false, false]
    end
  when /^=end/
    if_current_indent_equal("") do
      @in_part = nil
      [:WHITELINE, "=end"] # MUST CHANGE??
    end
  when /^\s*$/
    @i += 1 # next line
    return [:WHITELINE, ':WHITELINE']
  when /^(=+|\++)\s*/
    rest = $'                    # '
    mark = $1
    if_current_indent_equal("") do
      return [:HEADLINE, [Headline.mark_to_level(mark), rest]]
    end
  when /^<<<\s*(\S+)/
    file = $1
    if_current_indent_equal("") do
      suffix = file[-3 .. -1] 
      if suffix == ".rd" or suffix == ".rb"
	subtree = parse_subtree(get_included(file))
	[:SUBTREE, subtree]
      else
	[:INCLUDE, file]
      end
    end
  when /^(\s*)\*(\s*)/
    rest = $'                   # '
    newIndent = $2
    if_current_indent_equal($1) do
      if @in_verbatim
	[:STRINGLINE, line]
      else
	@indent_stack.push("\s" << newIndent)
	[:ITEMLISTLINE, rest]
      end
    end
  when /^(\s*)(\(\d+\))(\s*)/
    rest = $'                     # '
    mark = $2
    newIndent = $3
    if_current_indent_equal($1) do
      if @in_verbatim
	[:STRINGLINE, line]
      else
	@indent_stack.push("\s" * mark.size << newIndent)
	[:ENUMLISTLINE, rest]
      end
    end
  when /^(\s*):(\s*)/
    rest = $'                    # '
    newIndent = $2
    if_current_indent_equal($1) do
      if @in_verbatim
	[:STRINGLINE, line]
      else
	@indent_stack.push("\s" <<$2)
	[:DESCLISTLINE, rest]
      end
    end
  when /^(\s*)---(\s+|[^\s-])/
    rest = $'                   # '
    newIndent = $2
    if_current_indent_equal($1) do
      if @in_verbatim
	[:STRINGLINE, line]
      else
	if newIndent =~ /\s/
	  @indent_stack.push("\s\s\s" + newIndent)
	else
	  rest = newIndent + rest
	end
	[:METHODLISTLINE, rest]
      end
    end
  when /^(\s*)/
    if_current_indent_equal($1) do
      [:STRINGLINE, line]
    end
  else
    raise "[BUG] parsing error may occured."
  end
end

=begin private
  --- RDParser#if_current_indent_equal(indent)
        if (({@current_indent == ((|indent|))})) then yield block, otherwise
        process indentation.
=end
def if_current_indent_equal(indent)
  if @current_indent == indent
    @i += 1 # next line
    yield
  elsif indent.index(@current_indent) == 0
    @indent_stack.push(indent[@current_indent.size .. -1])
    [:INDENT, ":INDENT"]
  else
    @indent_stack.pop
    [:DEDENT, ":DEDENT"]
  end
end
private :if_current_indent_equal

def cut_off(src)
  ret = []
  whiteline_buf = []
  line = src.shift
  /^\s*/ =~ line
  indent = Regexp.quote($&)
  ret.push($')                 # '
  while line = src.shift
    if /^(\s*)$/ =~ line
      whiteline_buf.push(line)
    elsif /^#{indent}/ =~ line
      unless whiteline_buf.empty?
	ret.concat(whiteline_buf)
	whiteline_buf.clear
      end
      ret.push($')            # '
    else
      raise "[BUG]: probably Parser Error while cutting off.\n"
    end
  end
  ret
end
private :cut_off

def on_error( et, ev, _values )
  if @is_swaped
    line = @swaped_line
  else
    line = @src[@i]
  end
  
  raise ParseError, <<Msg

RD syntax error: line #{@i+1}:
#{line}

[BUG]: sorry, this seems to be RDtool's  bug.
et: #{et}
ev: #{ev}
Msg
end # '

def line_index
  @i
end

def parse_subtree(src)
  @subparser = RD::RDParser.new() unless @subparser
  
  @subparser.parse(src, @tree)
end
private :parse_subtree

def get_included(file)
  included = ""
  @tree.include_path.each do |dir|
    file_name = dir + "/" + file
    if test(?e, file_name)
      included = IO.readlines(file_name)
      break
    end
  end
  included
end
private :get_included

##### racc 1.1.0 generates ###

racc_reduce_table = [
 0, 0, :racc_error,
 1, 15, :_reduce_1,
 0, 15, :_reduce_2,
 2, 16, :_reduce_3,
 1, 16, :_reduce_none,
 1, 17, :_reduce_5,
 1, 17, :_reduce_6,
 1, 17, :_reduce_none,
 1, 17, :_reduce_8,
 1, 17, :_reduce_9,
 1, 17, :_reduce_10,
 1, 17, :_reduce_11,
 1, 21, :_reduce_12,
 1, 22, :_reduce_13,
 1, 18, :_reduce_14,
 2, 23, :_reduce_15,
 1, 23, :_reduce_16,
 3, 19, :_reduce_17,
 1, 25, :_reduce_18,
 2, 24, :_reduce_19,
 4, 24, :_reduce_20,
 2, 24, :_reduce_21,
 1, 24, :_reduce_22,
 1, 26, :_reduce_none,
 1, 26, :_reduce_none,
 1, 26, :_reduce_none,
 1, 26, :_reduce_none,
 1, 20, :_reduce_none,
 3, 20, :_reduce_28,
 4, 20, :_reduce_29,
 2, 31, :_reduce_30,
 1, 31, :_reduce_31,
 1, 27, :_reduce_32,
 2, 32, :_reduce_33,
 1, 32, :_reduce_34,
 3, 33, :_reduce_35,
 1, 28, :_reduce_36,
 2, 36, :_reduce_37,
 1, 36, :_reduce_38,
 3, 37, :_reduce_39,
 1, 29, :_reduce_40,
 2, 39, :_reduce_41,
 1, 39, :_reduce_42,
 3, 40, :_reduce_43,
 1, 30, :_reduce_44,
 2, 42, :_reduce_45,
 1, 42, :_reduce_46,
 3, 43, :_reduce_47,
 2, 41, :_reduce_48,
 1, 41, :_reduce_none,
 3, 41, :_reduce_50,
 1, 41, :_reduce_51,
 0, 41, :_reduce_52,
 2, 44, :_reduce_53,
 1, 44, :_reduce_none,
 1, 45, :_reduce_55,
 1, 45, :_reduce_56,
 1, 45, :_reduce_none,
 1, 45, :_reduce_58,
 2, 34, :_reduce_59,
 1, 34, :_reduce_60,
 2, 38, :_reduce_61,
 1, 38, :_reduce_62,
 2, 35, :_reduce_63,
 2, 35, :_reduce_64,
 2, 35, :_reduce_65,
 1, 35, :_reduce_66,
 1, 35, :_reduce_none,
 1, 35, :_reduce_68,
 0, 35, :_reduce_69 ]

racc_reduce_n = 70

racc_shift_n = 86

racc_action_table = [
    13,    18,    23,    27,    33,    59,    78,    57,    75,    21,
    84,    13,    18,    23,    27,    48,    13,    18,    23,    27,
    48,    74,    13,    18,    23,    27,    33,    59,    23,    66,
    57,    21,    13,    18,    23,    27,    33,    59,    79,    80,
    18,    21,    13,    18,    23,    27,    33,    39,    33,    48,
    57,    21,    13,    18,    23,    27,    33,    59,    83,    27,
    13,    21,    13,    18,    23,    27,    33,    59,    58,   nil,
   nil,    21,    13,    18,    23,    27,    33,     3,     6,    11,
    16,    21,    13,    18,    23,    27,    33,    59,   nil,   nil,
   nil,    21,    13,    18,    23,    27,    33,    59,   nil,   nil,
   nil,    21,    13,    18,    23,    27,    33,     3,     6,    11,
    16,    21,    13,    18,    23,    27,   nil,    39,   nil,   nil,
   nil,    21,    13,    18,    23,    27,    33,    59,   nil,   nil,
   nil,    21,    13,    18,    23,    27,    33,    59,   nil,   nil,
   nil,    21,    13,    18,    23,    27,    33,    59,    71,    68,
   nil,    21,   nil,    69,    85,    71,    68,    33,    49,   nil,
    69,    70,    52,    71,    68,    33,    49,   nil,    69,   nil,
    52,    13,    18,    23,    27 ]

racc_action_check = [
    77,    77,    77,    77,    77,    77,    53,    43,    50,    77,
    77,    47,    47,    47,    47,    47,    21,    21,    21,    21,
    21,    47,    63,    63,    63,    63,    63,    63,    31,    41,
    44,    63,    76,    76,    76,    76,    76,    76,    54,    58,
    19,    76,     9,     9,     9,     9,    18,     9,    13,    69,
    34,     9,    67,    67,    67,    67,    67,    67,    73,     8,
     2,    67,    65,    65,    65,    65,    65,    65,    35,   nil,
   nil,    65,     4,     4,     4,     4,     4,     4,     4,     4,
     4,     4,    52,    52,    52,    52,    52,    52,   nil,   nil,
   nil,    52,    51,    51,    51,    51,    51,    51,   nil,   nil,
   nil,    51,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    28,    28,    28,    28,   nil,    28,   nil,   nil,
   nil,    28,    39,    39,    39,    39,    39,    39,   nil,   nil,
   nil,    39,    40,    40,    40,    40,    40,    40,   nil,   nil,
   nil,    40,    42,    42,    42,    42,    42,    42,    82,    82,
   nil,    42,   nil,    82,    82,    46,    46,    23,    23,   nil,
    46,    46,    23,    72,    72,    27,    27,   nil,    72,   nil,
    27,    32,    32,    32,    32 ]

racc_action_default = [
    -2,   -42,   -32,   -10,    -1,   -34,   -11,    -4,   -44,   -69,
   -31,   -12,    -5,   -60,   -46,   -23,   -13,    -6,   -62,   -36,
   -24,   -70,    -7,   -52,   -38,   -25,    -8,   -52,   -69,   -26,
    -9,   -40,   -27,   -16,   -14,   -70,   -33,    -3,   -45,   -68,
   -66,   -70,   -67,   -59,   -61,   -37,   -70,   -70,   -22,   -51,
   -70,   -49,   -70,   -70,   -70,   -41,   -30,   -15,   -70,   -58,
   -55,   -56,   -57,   -65,   -54,   -63,   -35,   -64,   -21,   -70,
   -17,   -19,   -18,   -70,   -28,   -43,   -48,   -70,   -47,   -39,
    86,   -53,   -70,   -29,   -50,   -20 ]

racc_action_pointer = [
    99,   nil,    57,   nil,    69,   nil,   nil,   nil,    53,    39,
   nil,   nil,   nil,    41,   nil,   nil,   nil,   nil,    39,    36,
   nil,    13,   nil,   150,   nil,   nil,   nil,   158,   109,   nil,
   nil,    23,   168,   nil,    43,    68,   nil,   nil,   nil,   119,
   129,    16,   139,     0,    23,   nil,   148,     8,   nil,   nil,
    -5,    89,    79,    -7,    25,   nil,   nil,   nil,    39,   nil,
   nil,   nil,   nil,    19,   nil,    59,   nil,    49,   nil,    42,
   nil,   nil,   156,    45,   nil,   nil,    29,    -3,   nil,   nil,
   nil,   nil,   141,   nil,   nil,   nil ]

racc_goto_table = [
    46,    17,    22,    41,    12,    17,    22,    43,    12,    56,
    40,    42,    44,     7,    50,    45,     4,    37,    53,    81,
    36,    81,    54,    81,    56,    55,    72,    51,    47,    40,
    42,    51,    81,    81,    63,    65,    38,    67,    73,    35,
   nil,   nil,   nil,   nil,   nil,   nil,    76,    77,    82 ]

racc_goto_check = [
    10,     5,     6,    21,     4,     5,     6,     9,     4,    12,
     5,     6,     9,     3,    27,    23,     2,     3,    27,    31,
    19,    31,    21,    31,    12,    26,    10,     4,    17,     5,
     6,     4,    31,    31,    30,    30,    29,    30,    11,     1,
   nil,   nil,   nil,   nil,   nil,   nil,    30,    30,    10 ]

racc_goto_pointer = [
   nil,    39,    16,    13,     4,     1,     2,   nil,   nil,    -6,
   -21,    -9,   -23,   nil,   nil,   nil,   nil,     7,   nil,    18,
   nil,    -6,   nil,    -4,   nil,   nil,    -6,    -9,   nil,    28,
    -5,   -44 ]

racc_goto_default = [
   nil,   nil,   nil,   nil,    60,    61,    62,    26,    30,    34,
   nil,   nil,    10,    15,    20,    25,    29,    32,     2,     5,
     9,   nil,    19,    24,    28,    31,     1,   nil,     8,    14,
   nil,    64 ]

racc_token_table = {
 false => 0,
 Object.new => 1,
 :DUMMY => 2,
 :ITEMLISTLINE => 3,
 :ENUMLISTLINE => 4,
 :DESCLISTLINE => 5,
 :METHODLISTLINE => 6,
 :STRINGLINE => 7,
 :WHITELINE => 8,
 :SUBTREE => 9,
 :HEADLINE => 10,
 :INCLUDE => 11,
 :INDENT => 12,
 :DEDENT => 13 }

racc_nt_base = 14

Racc_arg = [
 racc_action_table,
 racc_action_check,
 racc_action_default,
 racc_action_pointer,
 racc_goto_table,
 racc_goto_check,
 racc_goto_default,
 racc_goto_pointer,
 racc_nt_base,
 racc_reduce_table,
 racc_token_table,
 racc_shift_n,
 racc_reduce_n ]

Racc_debug_parser = false

##### racc system variables end #####


 # reduce 0 omitted

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 9 )
  def _reduce_1( val, _values, result )
 result = DocumentElement.new(val[0])
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 11 )
  def _reduce_2( val, _values, result )
                           # empty RD.
                           # need return RDTree.
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 15 )
  def _reduce_3( val, _values, result )
 result.concat(val[1])
   result
  end
.,.,

 # reduce 4 omitted

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 18 )
  def _reduce_5( val, _values, result )
 result = val
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 19 )
  def _reduce_6( val, _values, result )
 result = val
   result
  end
.,.,

 # reduce 7 omitted

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 21 )
  def _reduce_8( val, _values, result )
 result = val
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 22 )
  def _reduce_9( val, _values, result )
 result = val
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 23 )
  def _reduce_10( val, _values, result )
 result = []
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 24 )
  def _reduce_11( val, _values, result )
 result = val[0].blocks
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 27 )
  def _reduce_12( val, _values, result )
 # val[0] is like [level, title]
			  title = @inline_parser.parse(val[0][1])
			  result = Headline.new(val[0][0], title)
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 31 )
  def _reduce_13( val, _values, result )
 result = Include.new(val[0])
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 35 )
  def _reduce_14( val, _values, result )
 # val[0] is Array of String
			  content = cut_off(val[0]).join("")
			  content = @inline_parser.parse(content)
			  result = TextBlock.new(content)
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 41 )
  def _reduce_15( val, _values, result )
 result.push(val[1])
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 42 )
  def _reduce_16( val, _values, result )
 result = val
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 46 )
  def _reduce_17( val, _values, result )
 # val[1] is Array of String
			  content = cut_off(val[1])
			  result = Verbatim.new(content)
			  # imform to lexer.
			  @in_verbatim = false
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 53 )
  def _reduce_18( val, _values, result )
 # val[0] is Array of String
			  content = cut_off(val[0])
			  result = Verbatim.new(content)
			  # imform to lexer.
			  @in_verbatim = false
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 60 )
  def _reduce_19( val, _values, result )
 result.push(val[1])
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 62 )
  def _reduce_20( val, _values, result )
 result.concat(val[2])
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 64 )
  def _reduce_21( val, _values, result )
 result.push("\n")
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 65 )
  def _reduce_22( val, _values, result )
 result = val
					# imform to lexer.
					@in_verbatim = true
   result
  end
.,.,

 # reduce 23 omitted

 # reduce 24 omitted

 # reduce 25 omitted

 # reduce 26 omitted

 # reduce 27 omitted

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 76 )
  def _reduce_28( val, _values, result )
 result = val[1]
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 78 )
  def _reduce_29( val, _values, result )
 result = val[1].push(val[2])
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 81 )
  def _reduce_30( val, _values, result )
 result.push(val[1])
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 82 )
  def _reduce_31( val, _values, result )
 result = val
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 87 )
  def _reduce_32( val, _values, result )
 result = ItemList.new(val[0])
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 90 )
  def _reduce_33( val, _values, result )
 result.push(val[1])
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 91 )
  def _reduce_34( val, _values, result )
 result = val
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 94 )
  def _reduce_35( val, _values, result )
 result = ItemListItem.new([val[0]].concat(val[1]))
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 99 )
  def _reduce_36( val, _values, result )
 result = EnumList.new(val[0])
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 102 )
  def _reduce_37( val, _values, result )
 result.push(val[1])
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 103 )
  def _reduce_38( val, _values, result )
 result = val
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 106 )
  def _reduce_39( val, _values, result )
 result = EnumListItem.new([val[0]].concat(val[1]))
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 111 )
  def _reduce_40( val, _values, result )
 result = DescList.new(val[0])
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 114 )
  def _reduce_41( val, _values, result )
			result.push(val[1])
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 115 )
  def _reduce_42( val, _values, result )
 result = val
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 118 )
  def _reduce_43( val, _values, result )
 term = @inline_parser.parse(val[0])
			  result = DescListItem.new(term, val[1])
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 124 )
  def _reduce_44( val, _values, result )
 result = MethodList.new(val[0])
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 127 )
  def _reduce_45( val, _values, result )
 result.push(val[1])
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 128 )
  def _reduce_46( val, _values, result )
 result = val
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 131 )
  def _reduce_47( val, _values, result )
 term = val[0].strip
			  result = MethodListItem.new(term, val[1])
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 136 )
  def _reduce_48( val, _values, result )
 result = [val[0]].concat(val[1])
   result
  end
.,.,

 # reduce 49 omitted

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 138 )
  def _reduce_50( val, _values, result )
 result = val[1]
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 139 )
  def _reduce_51( val, _values, result )
 result = []
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 140 )
  def _reduce_52( val, _values, result )
 result = []
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 143 )
  def _reduce_53( val, _values, result )
 result.concat(val[1])
   result
  end
.,.,

 # reduce 54 omitted

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 146 )
  def _reduce_55( val, _values, result )
 result = val
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 147 )
  def _reduce_56( val, _values, result )
 result = val
   result
  end
.,.,

 # reduce 57 omitted

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 149 )
  def _reduce_58( val, _values, result )
 result = []
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 153 )
  def _reduce_59( val, _values, result )
 content = cut_off([val[0]].concat(val[1])).join("")
		  content = @inline_parser.parse(content)
		  result = TextBlock.new(content)
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 157 )
  def _reduce_60( val, _values, result )
 content = cut_off([val[0]]).join("")
		  content = @inline_parser.parse(content)
		  result = TextBlock.new(content)
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 162 )
  def _reduce_61( val, _values, result )
 content = cut_off([val[0]].concat(val[1])).join("")
		  content = @inline_parser.parse(content)
		  result = TextBlock.new(content)
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 166 )
  def _reduce_62( val, _values, result )
 content = cut_off([val[0]]).join("")
		  content = @inline_parser.parse(content)
		  result = TextBlock.new(content)
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 171 )
  def _reduce_63( val, _values, result )
 result = [val[0]].concat(val[1])
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 172 )
  def _reduce_64( val, _values, result )
 result.concat(val[1])
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 173 )
  def _reduce_65( val, _values, result )
 result = val[1]
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 174 )
  def _reduce_66( val, _values, result )
 result = val
   result
  end
.,.,

 # reduce 67 omitted

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 176 )
  def _reduce_68( val, _values, result )
 result = []
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdblockparser.ry', 177 )
  def _reduce_69( val, _values, result )
 result = []
   result
  end
.,.,

end
end # end of module RD 
