#
# missing/rdinlineparser.tab.rb: generated by racc (runtime embedded)
#

###### racc/parser.rb

unless $".index 'racc/parser.rb.rb' then
$".push 'racc/parser.rb.rb'
#
# parser.rb
#
#   Copyright (c) 1999,2000 Minero Aoki <aamine@dp.u-netsurf.ne.jp>
#
#   This program is free software.
#   You can distribute/modify this program under the terms of
#   the GNU Lesser General Public License version 2 or later.
#
#   As a special exception, when this code is copied by Racc
#   into a Racc output file, you may use that output file
#   without restriction.
#

unless defined? ParseError then
  class ParseError < StandardError; end
end


module Racc


class Parser

  private


  begin
    require 'racc/cparse'   # def _c_parse
    Racc_Main_Parsing_Routine = :_c_parse
  rescue LoadError
    Racc_Main_Parsing_Routine = :_rb_parse
  end


  def next_token
    raise NotImplementError, "#{self.type}#next_token must be defined"
  end


  def do_parse
    t = self.type
    unless t::Racc_debug_parser then
      @yydebug = false
    end
    @yydebug = @yydebug ? true : false
    if @yydebug then
      @racc_debug_out ||= $stderr
    end

    send Racc_Main_Parsing_Routine, t::Racc_arg, false
  end


  def _rb_parse( arg, in_debug )
    action_table, action_check, action_default, action_pointer,
    goto_table, goto_check, goto_default, goto_pointer,
    nt_base, reduce_table, token_table, shift_n, reduce_n = *arg

    #
    # local variables
    #

    state    = [ 0 ]
    curstate = 0

    tstack = []
    vstack = []

    atmp = tok = val = t = nil
    act = tmp = code = i = nil
    read_next = true

    @racc_error_status = 0
    nerr = 0
    user_yyerror = false

    t_end = 0    # $end
    t_err = 1    # error token

    yydebug = @yydebug

    #
    # LR parsing algorithm main loop
    #

    while true do

      if i = action_pointer[ curstate ] then
        if read_next then
          if t != t_end then
            atmp = next_token
            tok = atmp[0]
            val = atmp[1]
            t = (token_table[tok] or t_err)
            racc_read_token( t, tok, val ) if yydebug

            read_next = false
          end
        end
        i += t
        if i >= 0 and act = action_table[i] and
           action_check[i] == curstate then
        else
          act = action_default[ curstate ]
        end
      else
        act = action_default[ curstate ]
      end

  begin
      if act > 0 and act < shift_n then
        #
        # shift
        #

        if @racc_error_status > 0 then
          @racc_error_status -= 1
        end

        vstack.push val
        if yydebug then
          tstack.push t
          racc_shift( t, tstack, vstack )
        end

        curstate = act
        state.push curstate

        read_next = true

      elsif act < 0 and act > -reduce_n then
        #
        # reduce
        #

        code = catch( :racc_jump ) {
          curstate = racc_do_reduce( arg, state, vstack, tstack, act )
          state.push curstate; false
        }
        if code then
          case code
          when 1 # yyerror
            act = -reduce_n
            user_yyerror = true
            redo
          when 2 # yyaccept
            act = shift_n
            redo
          else
            raise RuntimeError, '[Racc Bug] unknown jump code'
          end
        end

      elsif act == shift_n then
        #
        # accept
        #

        racc_accept if yydebug
        return vstack[0]

      elsif act == -reduce_n then
        #
        # error
        #

        case @racc_error_status
        when 0
          unless user_yyerror then
            nerr += 1
            on_error( t, val, vstack )
          end
        when 3
          if t == t_end then
            return nil
          end
          read_next = true
        end
        user_yyerror = false
        @racc_error_status = 3

        while true do
          if i = action_pointer[curstate] then
            i += t_err
            if i >= 0 and
               (act = action_table[i]) and
               action_check[i] == curstate then
              break
            end
          end

          return nil if state.size < 2
          state.pop
          vstack.pop
          if yydebug then
            tstack.pop
            racc_e_pop( state, tstack, vstack )
          end
          curstate = state[-1]
        end

        if act > 0 and act < shift_n then
          #
          # error-shift
          #
          vstack.push val
          if yydebug then
            tstack.push t_err
            racc_shift( t_err, tstack, vstack )
          end

          curstate = act
          state.push curstate
          
        elsif act < 0 and act > -reduce_n then
          #
          # error-reduce
          #
          code = catch( :racc_jump ) {
            curstate = racc_do_reduce( arg, state, vstack, tstack, act )
            state.push curstate; 0
          }
          unless code == 0 then
            case code
            when 1 # yyerror
              act = -reduce_n
              user_yyerror = true
              redo
            when 2 # yyaccept
              act = shift_n
              redo
            else
              raise RuntimeError, '[Racc Bug] unknown jump code'
            end
          end

        elsif act == shift_n then
          #
          # error-accept
          #
          racc_accept if yydebug
          return vstack[0]

        else
          raise RuntimeError, "[Racc Bug] wrong act value #{act.inspect}"
        end

      else
        raise RuntimeError, "[Racc Bug] unknown action #{act.inspect}"
      end
  end while false

      racc_next_state( curstate, state ) if yydebug
    end

    raise RuntimeError, '[Racc Bug] must not reach here'
  end


  def on_error( t, val, vstack )
    raise ParseError, "\nunexpected token #{val.inspect}"
  end


  def racc_do_reduce( arg, state, vstack, tstack, act )
    action_table, action_check, action_default, action_pointer,
    goto_table, goto_check, goto_default, goto_pointer,
    nt_base, reduce_table, token_table, shift_n, reduce_n = *arg

    i = act * -3
    len       = reduce_table[i]
    reduce_to = reduce_table[i+1]
    method_id = reduce_table[i+2]
    void_array = []

    tmp_t = tstack[ -len, len ] if @yydebug
    tmp_v = vstack[ -len, len ]
    tstack[ -len, len ] = void_array if @yydebug
    vstack[ -len, len ] = void_array
    state[ -len, len ]  = void_array

    # tstack must be renewed AFTER method call
    vstack.push( (method_id == :_reduce_none) ?
                     tmp_v[0] : send(method_id, tmp_v, vstack, tmp_v[0]) )
    tstack.push reduce_to

    racc_reduce( tmp_t, reduce_to, tstack, vstack ) if @yydebug

    k1 = reduce_to - nt_base
    if i = goto_pointer[ k1 ] then
      i += state[-1]
      if i >= 0 and (curstate = goto_table[i]) and goto_check[i] == k1 then
        return curstate
      end
    end
    goto_default[ k1 ]
  end

  def yyerror
    throw :racc_jump, 1
  end

  def yyaccept
    throw :racc_jump, 2
  end

  def yyerrok
    @racc_error_status = 0
  end


  # for debugging output

  def racc_read_token( t, tok, val )
    @racc_debug_out.print 'read    '
    @racc_debug_out.print tok.inspect, '(internaly ', racc_token2str(t), ') '
    @racc_debug_out.puts val.inspect
    @racc_debug_out.puts
  end

  def racc_shift( tok, tstack, vstack )
    @racc_debug_out.puts "shift   #{racc_token2str tok}"
    racc_print_stacks tstack, vstack
    @racc_debug_out.puts
  end

  def racc_reduce( toks, sim, tstack, vstack )
    out = @racc_debug_out
    out.print 'reduce '
    if toks.empty? then
      out.print ' <none>'
    else
      toks.each {|t| out.print ' ', racc_token2str(t) }
    end
    out.puts " --> #{racc_token2str(sim)}"
        
    racc_print_stacks tstack, vstack
    @racc_debug_out.puts
  end

  def racc_accept
    @racc_debug_out.puts 'accept'
    @racc_debug_out.puts
  end

  def racc_e_pop( state, tstack, vstack )
    @racc_debug_out.puts 'error recovering mode: pop token'
    racc_print_states state
    racc_print_stacks tstack, vstack
    @racc_debug_out.puts
  end

  def racc_next_state( curstate, state )
    @racc_debug_out.puts  "goto    #{curstate}"
    racc_print_states state
    @racc_debug_out.puts
  end

  def racc_print_stacks( t, v )
    out = @racc_debug_out
    out.print '        ['
    t.each_index do |i|
      out.print ' (', racc_token2str(t[i]), ' ', v[i].inspect, ')'
    end
    out.puts ' ]'
  end

  def racc_print_states( s )
    out = @racc_debug_out
    out.print '        ['
    s.each {|st| out.print ' ', st }
    out.puts ' ]'
  end

  def racc_token2str( tok )
    type::Racc_token_to_s_table[tok] or
      raise RuntimeError, "[Racc Bug] can't convert token #{tok} to string"
  end

end


end   # module Racc
end   # end of racc/parser.rb

=begin
= rdinlineparser.ry
== What is rdinlineparser.ry
rdinlineparser.ry is Racc syntax definition file for Inline level
parsing. rdinlineparser.tab.rb is required by rdblockparser.tab.rb,
and RDInlineParser is used RDBlockParser.

Please read rdblockparser.ry for more details.

== Inline level parsing
Inline level parsing is very simple. You can easily understand it
when you read BNF in rdinlineparser.ry.

Now RDInlineParser can parse only regular RD. "regular" means Inline
brackets are exactly nested. For example,
  This is regular
  ((- Footnote and ((*Em*)). -))
  And they are ilregular
  ((- Footnote and ((*Emphasis -)) . *))
  ((- Not closed pair of bracket.
When RDInlineParser meats such a ilregular RD, RDInlineParser raises
a Exception...
== Inline level lexical analizing
In Inline level, lexer do all lexical analizing before parsing. Each
tokens are pushed into (({@token_queue})) and each values into 
(({@value_queue})).
=end
=begin
== script info.
 parser for RD Inline.
 $Id: rdinlineparser.ry,v 1.24 2000/06/24 17:05:26 toshirok Exp $

=end

require "strscan"

module RD
class RDInlineParser < Racc::Parser
EM_OPEN = '((*'
EM_OPEN_RE = /#{Regexp.quote(EM_OPEN)}/
EM_CLOSE = '*))'
EM_CLOSE_RE = /#{Regexp.quote(EM_CLOSE)}/
CODE_OPEN = '(({'
CODE_OPEN_RE = /#{Regexp.quote(CODE_OPEN)}/
CODE_CLOSE = '}))'
CODE_CLOSE_RE = /#{Regexp.quote(CODE_CLOSE)}/
VAR_OPEN = '((|'
VAR_OPEN_RE = /#{Regexp.quote(VAR_OPEN)}/
VAR_CLOSE = '|))'
VAR_CLOSE_RE = /#{Regexp.quote(VAR_CLOSE)}/
KBD_OPEN = '((%'
KBD_OPEN_RE = /#{Regexp.quote(KBD_OPEN)}/
KBD_CLOSE = '%))'
KBD_CLOSE_RE = /#{Regexp.quote(KBD_CLOSE)}/
INDEX_OPEN = '((:'
INDEX_OPEN_RE = /#{Regexp.quote(INDEX_OPEN)}/
INDEX_CLOSE = ':))'
INDEX_CLOSE_RE = /#{Regexp.quote(INDEX_CLOSE)}/
REF_OPEN = '((<'
REF_OPEN_RE = /#{Regexp.quote(REF_OPEN)}/
REF_CLOSE = '>))'
REF_CLOSE_RE = /#{Regexp.quote(REF_CLOSE)}/
FOOTNOTE_OPEN = '((-'
FOOTNOTE_OPEN_RE = /#{Regexp.quote(FOOTNOTE_OPEN)}/
FOOTNOTE_CLOSE = '-))'
FOOTNOTE_CLOSE_RE = /#{Regexp.quote(FOOTNOTE_CLOSE)}/
VERB_OPEN = "(('"
VERB_OPEN_RE = /#{Regexp.quote(VERB_OPEN)}/
VERB_CLOSE = "'))"
VERB_CLOSE_RE = /#{Regexp.quote(VERB_CLOSE)}/

BAR = "|"
BAR_RE = /#{Regexp.quote(BAR)}/
QUOTE = '"'
QUOTE_RE = /#{Regexp.quote(QUOTE)}/
SLASH = "/"
SLASH_RE = /#{Regexp.quote(SLASH)}/
BACK_SLASH = "\\"
BACK_SLASH_RE = /#{Regexp.quote(BACK_SLASH)}/
URL = "URL:"
URL_RE = /#{Regexp.quote(URL)}/

# Workaround for Regexp option change of Ruby 1.5.x
other_re_mode = Regexp::EXTENDED
if RUBY_VERSION > "1.5"
  other_re_mode |= Regexp::MULTILINE
else
  other_re_mode |= Regexp::POSIXLINE
end

OTHER_RE = Regexp.new(
		  ".+?(?=#{Regexp.quote(EM_OPEN)}|#{Regexp.quote(EM_CLOSE)}|
                  #{Regexp.quote(CODE_OPEN)}|#{Regexp.quote(CODE_CLOSE)}|
                  #{Regexp.quote(VAR_OPEN)}|#{Regexp.quote(VAR_CLOSE)}|
                  #{Regexp.quote(KBD_OPEN)}|#{Regexp.quote(KBD_CLOSE)}|
                  #{Regexp.quote(INDEX_OPEN)}|#{Regexp.quote(INDEX_CLOSE)}|
                  #{Regexp.quote(REF_OPEN)}|#{Regexp.quote(REF_CLOSE)}|
                #{Regexp.quote(FOOTNOTE_OPEN)}|#{Regexp.quote(FOOTNOTE_CLOSE)}|
                  #{Regexp.quote(VERB_OPEN)}|#{Regexp.quote(VERB_CLOSE)}|
                  #{Regexp.quote(BAR)}|
                  #{Regexp.quote(QUOTE)}|
                  #{Regexp.quote(SLASH)}|
                  #{Regexp.quote(BACK_SLASH)}|
                  #{Regexp.quote(URL)})", other_re_mode)

def initialize(bp)
  @blockp = bp
end

def parse(src)
  @src = StringScanner.new(src)
  @pre = ""
  @yydebug = true
  do_parse
end

def next_token
  return [false, false] if @src.empty?
#  p @src.rest if @yydebug
  if ret = @src.scan(EM_OPEN_RE)
    @pre << ret
    [:EM_OPEN, ret]
  elsif ret = @src.scan(EM_CLOSE_RE)
    @pre << ret
    [:EM_CLOSE, ret]
  elsif ret = @src.scan(CODE_OPEN_RE)
    @pre << ret
    [:CODE_OPEN, ret]
  elsif ret = @src.scan(CODE_CLOSE_RE)
    @pre << ret
    [:CODE_CLOSE, ret]
  elsif ret = @src.scan(VAR_OPEN_RE)
    @pre << ret
    [:VAR_OPEN, ret]
  elsif ret = @src.scan(VAR_CLOSE_RE)
    @pre << ret
    [:VAR_CLOSE, ret]
  elsif ret = @src.scan(KBD_OPEN_RE)
    @pre << ret
    [:KBD_OPEN, ret]
  elsif ret = @src.scan(KBD_CLOSE_RE)
    @pre << ret
    [:KBD_CLOSE, ret]
  elsif ret = @src.scan(INDEX_OPEN_RE)
    @pre << ret
    [:INDEX_OPEN, ret]
  elsif ret = @src.scan(INDEX_CLOSE_RE)
    @pre << ret
    [:INDEX_CLOSE, ret]
  elsif ret = @src.scan(REF_OPEN_RE)
    @pre << ret
    [:REF_OPEN, ret]
  elsif ret = @src.scan(REF_CLOSE_RE)
    @pre << ret
    [:REF_CLOSE, ret]
  elsif ret = @src.scan(FOOTNOTE_OPEN_RE)
    @pre << ret
    [:FOOTNOTE_OPEN, ret]
  elsif ret = @src.scan(FOOTNOTE_CLOSE_RE)
    @pre << ret
    [:FOOTNOTE_CLOSE, ret]
  elsif ret = @src.scan(VERB_OPEN_RE)
    @pre << ret
    [:VERB_OPEN, ret]
  elsif ret = @src.scan(VERB_CLOSE_RE)
    @pre << ret
    [:VERB_CLOSE, ret]
  elsif ret = @src.scan(BAR_RE)
    @pre << ret
    [:BAR, ret]
  elsif ret = @src.scan(QUOTE_RE)
    @pre << ret
    [:QUOTE, ret]
  elsif ret = @src.scan(SLASH_RE)
    @pre << ret
    [:SLASH, ret]
  elsif ret = @src.scan(BACK_SLASH_RE)
    @pre << ret
    [:BACK_SLASH, ret]
  elsif ret = @src.scan(URL_RE)
    @pre << ret
    [:URL, ret]
  elsif ret = @src.scan(OTHER_RE)
    @pre << ret
    [:OTHER, ret]
  else
    ret = @src.rest
    @pre << ret
    @src.clear
    [:OTHER, ret]
  end
end

def on_error(et, ev, values)
  line_num = @pre.to_a.size - 1
  if /\n/ =~ @src.rest
    next_words = $`
  else
    next_words = @src.rest
  end
  
  raise ParseError, <<Msg

RD syntax error: line #{@blockp.line_index - line_num}:
... #{(ev||'') + next_words} ...
   ^
    
Msg
end

##### racc 1.1.0 generates ###

racc_reduce_table = [
 0, 0, :racc_error,
 1, 27, :_reduce_none,
 2, 28, :_reduce_2,
 1, 28, :_reduce_3,
 1, 29, :_reduce_none,
 1, 29, :_reduce_none,
 1, 29, :_reduce_none,
 1, 29, :_reduce_none,
 1, 29, :_reduce_none,
 1, 29, :_reduce_none,
 1, 29, :_reduce_none,
 1, 29, :_reduce_none,
 1, 29, :_reduce_none,
 3, 30, :_reduce_13,
 3, 31, :_reduce_14,
 3, 32, :_reduce_15,
 3, 33, :_reduce_16,
 3, 34, :_reduce_17,
 4, 35, :_reduce_18,
 3, 35, :_reduce_19,
 2, 40, :_reduce_20,
 2, 40, :_reduce_21,
 1, 40, :_reduce_22,
 1, 40, :_reduce_23,
 2, 41, :_reduce_24,
 2, 41, :_reduce_25,
 1, 41, :_reduce_26,
 1, 41, :_reduce_27,
 2, 39, :_reduce_none,
 4, 39, :_reduce_29,
 2, 43, :_reduce_none,
 4, 43, :_reduce_31,
 1, 44, :_reduce_32,
 3, 44, :_reduce_33,
 1, 45, :_reduce_none,
 3, 45, :_reduce_35,
 2, 46, :_reduce_36,
 2, 46, :_reduce_37,
 1, 46, :_reduce_38,
 1, 46, :_reduce_39,
 1, 47, :_reduce_none,
 2, 51, :_reduce_41,
 1, 51, :_reduce_42,
 2, 53, :_reduce_43,
 1, 53, :_reduce_44,
 1, 50, :_reduce_none,
 1, 50, :_reduce_none,
 1, 50, :_reduce_none,
 1, 50, :_reduce_none,
 1, 50, :_reduce_none,
 1, 50, :_reduce_none,
 1, 54, :_reduce_none,
 1, 54, :_reduce_none,
 1, 55, :_reduce_none,
 1, 55, :_reduce_none,
 1, 56, :_reduce_55,
 1, 52, :_reduce_56,
 1, 57, :_reduce_57,
 2, 58, :_reduce_58,
 1, 58, :_reduce_none,
 2, 48, :_reduce_60,
 1, 48, :_reduce_none,
 2, 49, :_reduce_62,
 1, 49, :_reduce_none,
 1, 60, :_reduce_none,
 1, 60, :_reduce_none,
 1, 60, :_reduce_none,
 1, 60, :_reduce_none,
 1, 60, :_reduce_none,
 1, 62, :_reduce_none,
 1, 62, :_reduce_none,
 1, 59, :_reduce_none,
 1, 59, :_reduce_none,
 1, 61, :_reduce_none,
 1, 61, :_reduce_none,
 1, 61, :_reduce_none,
 2, 42, :_reduce_76,
 1, 42, :_reduce_none,
 1, 63, :_reduce_none,
 2, 63, :_reduce_none,
 1, 63, :_reduce_none,
 1, 63, :_reduce_none,
 1, 63, :_reduce_none,
 1, 63, :_reduce_none,
 1, 63, :_reduce_none,
 1, 63, :_reduce_none,
 1, 63, :_reduce_none,
 1, 63, :_reduce_none,
 1, 63, :_reduce_none,
 1, 63, :_reduce_none,
 1, 63, :_reduce_none,
 1, 63, :_reduce_none,
 1, 63, :_reduce_none,
 1, 63, :_reduce_none,
 1, 63, :_reduce_none,
 1, 63, :_reduce_none,
 1, 63, :_reduce_none,
 1, 63, :_reduce_none,
 1, 63, :_reduce_none,
 3, 36, :_reduce_99,
 3, 37, :_reduce_100,
 1, 65, :_reduce_none,
 1, 65, :_reduce_none,
 1, 65, :_reduce_none,
 1, 65, :_reduce_none,
 1, 65, :_reduce_none,
 1, 65, :_reduce_none,
 2, 66, :_reduce_107,
 1, 66, :_reduce_none,
 1, 38, :_reduce_109,
 1, 67, :_reduce_none,
 1, 67, :_reduce_none,
 1, 67, :_reduce_none,
 1, 67, :_reduce_none,
 1, 67, :_reduce_none,
 1, 67, :_reduce_none,
 1, 67, :_reduce_none,
 1, 67, :_reduce_none,
 1, 67, :_reduce_none,
 1, 67, :_reduce_none,
 1, 67, :_reduce_none,
 1, 67, :_reduce_none,
 1, 67, :_reduce_none,
 1, 67, :_reduce_none,
 1, 67, :_reduce_none,
 1, 67, :_reduce_none,
 1, 67, :_reduce_none,
 1, 67, :_reduce_none,
 1, 67, :_reduce_none,
 2, 67, :_reduce_129,
 2, 67, :_reduce_130,
 1, 67, :_reduce_none,
 2, 64, :_reduce_132,
 1, 64, :_reduce_none ]

racc_reduce_n = 134

racc_shift_n = 174

racc_action_table = [
   127,   129,   132,   135,   137,   118,   120,   122,   125,   151,
   131,   134,   136,   117,   121,   123,   126,   128,   130,   133,
   159,   116,   119,   127,   129,   132,   135,   137,   118,   120,
   122,   125,   145,   131,   134,   136,   117,   121,   123,   126,
   128,   130,   133,   115,   116,   119,   127,   129,   132,   135,
   137,   118,   120,   122,   125,   161,   131,   134,   136,   117,
   121,   123,   126,   128,   130,   133,    87,   116,   119,    40,
    42,    45,    46,    49,    31,    33,    35,    38,   162,    44,
    48,    51,    30,    34,    36,    39,    41,    43,    47,    50,
    29,    83,   127,   129,   132,   135,   137,   118,   120,   122,
   125,   146,   131,   134,   136,   117,   121,   123,   126,   128,
   130,   133,    88,   116,   119,    11,    15,    18,    23,    26,
     1,     5,     9,    87,   147,    20,    86,    27,   168,     6,
   169,    12,   170,    19,    78,   149,     2,    11,    15,    18,
    23,    26,     1,     5,     9,    85,   150,    20,   169,    27,
   148,     6,   nil,    12,   nil,    19,    92,   nil,     2,    68,
    98,    52,    56,    58,    62,   nil,    20,   nil,    27,   nil,
     6,   nil,    12,   nil,    19,   nil,   nil,     2,    11,    15,
    18,    23,    26,     1,     5,     9,   nil,   nil,    20,   nil,
    27,   nil,     6,   nil,    12,   nil,    19,   nil,   nil,     2,
    11,    15,    18,    23,    26,     1,     5,     9,   nil,   nil,
    20,   nil,    27,   nil,     6,   nil,    12,   nil,    19,   nil,
   nil,     2,    11,    15,    18,    23,    26,     1,     5,     9,
   nil,   nil,    20,   nil,    27,   nil,     6,   nil,    12,   nil,
    19,   nil,   nil,     2,    11,    15,    18,    23,    26,     1,
     5,     9,   nil,   nil,    20,   nil,    27,   nil,     6,   nil,
    12,   nil,    19,   nil,   nil,     2,    11,    15,    18,    23,
    26,     1,     5,     9,   nil,   nil,    20,   nil,    27,   nil,
     6,   nil,    12,   nil,    19,    63,   nil,     2,    68,    71,
    52,    56,    58,    62,   nil,    20,   nil,    27,   nil,     6,
   nil,    12,   nil,    19,   nil,   nil,     2,    40,    42,    45,
    46,    49,    31,    33,    35,    38,   nil,    44,    48,    51,
    30,    34,    36,    39,    41,    43,    47,    50,    29,    92,
   nil,   nil,    68,    98,    52,    56,    58,    62,   nil,    20,
   nil,    27,   nil,     6,   nil,    12,   nil,    19,    92,   nil,
     2,    68,    98,    52,    56,    58,    62,   nil,    20,   nil,
    27,   nil,     6,   nil,    12,   100,    19,   nil,    68,     2,
    52,    56,    58,    62,   nil,    20,   nil,    27,   nil,     6,
   nil,    12,   nil,    19,   nil,   nil,     2,    11,    15,    18,
    23,    26,     1,     5,     9,   nil,   nil,    20,   nil,    27,
   nil,     6,   nil,    12,   nil,    19,    92,   nil,     2,    68,
    98,    52,    56,    58,    62,   nil,    20,   nil,    27,   nil,
     6,   nil,    12,   nil,    19,   nil,   nil,     2,   106,   107,
    68,    98,    52,    56,    58,    62,   nil,    20,   nil,    27,
   nil,     6,   nil,    12,   nil,    19,   nil,   nil,     2,   106,
   107,    68,    98,    52,    56,    58,    62,   nil,    20,   nil,
    27,   nil,     6,   nil,    12,   nil,    19,   nil,   nil,     2,
   106,   107,    68,    98,    52,    56,    58,    62,   nil,    20,
   nil,    27,   nil,     6,   nil,    12,   nil,    19,    92,   nil,
     2,    68,    98,    52,    56,    58,    62,   171,   106,   107,
    68,    98,    52,    56,    58,    62,   156,   106,   107,    68,
    98,    52,    56,    58,    62,    92,   nil,   nil,    68,    98,
    52,    56,    58,    62,   141,   nil,   nil,    68,   144,    52,
    56,    58,    62,   165,   nil,   nil,    68,   nil,    52,    56,
    58,    62,   173,   106,   107,    68,    98,    52,    56,    58,
    62,   106,   107,    68,    98,    52,    56,    58,    62,   106,
   107,    68,    98,    52,    56,    58,    62,   106,   107,    68,
    98,    52,    56,    58,    62,    11,    15,    18,    23,    26,
     1 ]

racc_action_check = [
   124,   124,   124,   124,   124,   124,   124,   124,   124,    82,
   124,   124,   124,   124,   124,   124,   124,   124,   124,   124,
   112,   124,   124,   144,   144,   144,   144,   144,   144,   144,
   144,   144,    74,   144,   144,   144,   144,   144,   144,   144,
   144,   144,   144,    70,   144,   144,    71,    71,    71,    71,
    71,    71,    71,    71,    71,   135,    71,    71,    71,    71,
    71,    71,    71,    71,    71,    71,   139,    71,    71,    32,
    32,    32,    32,    32,    32,    32,    32,    32,   140,    32,
    32,    32,    32,    32,    32,    32,    32,    32,    32,    32,
    32,    32,   167,   167,   167,   167,   167,   167,   167,   167,
   167,    76,   167,   167,   167,   167,   167,   167,   167,   167,
   167,   167,    55,   167,   167,    19,    19,    19,    19,    19,
    19,    19,    19,    53,    77,    19,    46,    19,   155,    19,
   156,    19,   159,    19,    14,    80,    19,    12,    12,    12,
    12,    12,    12,    12,    12,    46,    81,    12,   171,    12,
    78,    12,   nil,    12,   nil,    12,   114,   nil,    12,   114,
   114,   114,   114,   114,   114,   nil,   114,   nil,   114,   nil,
   114,   nil,   114,   nil,   114,   nil,   nil,   114,    17,    17,
    17,    17,    17,    17,    17,    17,   nil,   nil,    17,   nil,
    17,   nil,    17,   nil,    17,   nil,    17,   nil,   nil,    17,
     9,     9,     9,     9,     9,     9,     9,     9,   nil,   nil,
     9,   nil,     9,   nil,     9,   nil,     9,   nil,     9,   nil,
   nil,     9,    20,    20,    20,    20,    20,    20,    20,    20,
   nil,   nil,    20,   nil,    20,   nil,    20,   nil,    20,   nil,
    20,   nil,   nil,    20,    27,    27,    27,    27,    27,    27,
    27,    27,   nil,   nil,    27,   nil,    27,   nil,    27,   nil,
    27,   nil,    27,   nil,   nil,    27,     6,     6,     6,     6,
     6,     6,     6,     6,   nil,   nil,     6,   nil,     6,   nil,
     6,   nil,     6,   nil,     6,     5,   nil,     6,     5,     5,
     5,     5,     5,     5,   nil,     5,   nil,     5,   nil,     5,
   nil,     5,   nil,     5,   nil,   nil,     5,     2,     2,     2,
     2,     2,     2,     2,     2,     2,   nil,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,    65,
   nil,   nil,    65,    65,    65,    65,    65,    65,   nil,    65,
   nil,    65,   nil,    65,   nil,    65,   nil,    65,    60,   nil,
    65,    60,    60,    60,    60,    60,    60,   nil,    60,   nil,
    60,   nil,    60,   nil,    60,    61,    60,   nil,    61,    60,
    61,    61,    61,    61,   nil,    61,   nil,    61,   nil,    61,
   nil,    61,   nil,    61,   nil,   nil,    61,     0,     0,     0,
     0,     0,     0,     0,     0,   nil,   nil,     0,   nil,     0,
   nil,     0,   nil,     0,   nil,     0,    94,   nil,     0,    94,
    94,    94,    94,    94,    94,   nil,    94,   nil,    94,   nil,
    94,   nil,    94,   nil,    94,   nil,   nil,    94,   109,   109,
   109,   109,   109,   109,   109,   109,   nil,   109,   nil,   109,
   nil,   109,   nil,   109,   nil,   109,   nil,   nil,   109,    63,
    63,    63,    63,    63,    63,    63,    63,   nil,    63,   nil,
    63,   nil,    63,   nil,    63,   nil,    63,   nil,   nil,    63,
   100,   100,   100,   100,   100,   100,   100,   100,   nil,   100,
   nil,   100,   nil,   100,   nil,   100,   nil,   100,    64,   nil,
   100,    64,    64,    64,    64,    64,    64,   163,   163,   163,
   163,   163,   163,   163,   163,   163,   103,   103,   103,   103,
   103,   103,   103,   103,   103,    90,   nil,   nil,    90,    90,
    90,    90,    90,    90,    73,   nil,   nil,    73,    73,    73,
    73,    73,    73,   142,   nil,   nil,   142,   nil,   142,   142,
   142,   142,   172,   172,   172,   172,   172,   172,   172,   172,
   172,   141,   141,   141,   141,   141,   141,   141,   141,   154,
   154,   154,   154,   154,   154,   154,   154,   165,   165,   165,
   165,   165,   165,   165,   165,     8,     8,     8,     8,     8,
     8 ]

racc_action_default = [
  -134,  -101,  -134,    -6,  -108,  -134,  -134,    -7,  -109,  -134,
    -8,  -102,  -134,    -9,  -134,  -103,   -10,    -1,  -104,  -134,
  -134,   -11,    -3,  -105,   -12,    -4,  -106,  -134,    -5,  -128,
  -117,  -110,  -134,  -124,  -118,  -126,  -119,  -133,  -127,  -120,
  -111,  -121,  -112,  -122,  -114,  -113,  -134,  -123,  -115,  -131,
  -125,  -116,   -64,   -56,   -47,  -134,   -66,   -48,   -67,   -49,
   -39,   -27,   -68,  -134,   -61,   -38,   -26,   -50,   -65,   -45,
   -34,  -134,   -46,  -134,  -134,  -107,  -134,  -134,  -134,    -2,
  -134,  -134,  -134,  -100,  -132,  -129,  -130,   -30,   -19,   -52,
   -55,   -51,   -72,   -59,   -36,   -69,   -71,   -42,   -70,   -56,
  -134,   -25,   -34,   -57,   -54,   -53,   -74,   -75,   -63,   -40,
   -73,   -44,  -134,   -60,   -37,   -28,   -97,   -87,   -78,   -98,
   -94,   -88,   -95,   -89,   -24,   -96,   -90,   -83,   -91,   -82,
   -92,   -84,   -81,   -93,   -85,  -134,   -86,   -80,   -77,   -32,
  -134,  -134,   -23,   -22,  -134,   -15,   -99,   -16,   174,   -17,
   -13,   -14,   -58,   -41,   -57,  -134,  -134,   -62,   -43,   -35,
   -76,   -79,   -18,  -134,   -32,  -134,   -21,   -20,   -35,   -31,
   -29,   -33,  -134,   -33 ]

racc_action_pointer = [
   384,   nil,   304,   nil,   nil,   282,   263,   nil,   572,   197,
   nil,   nil,   134,   nil,   134,   nil,   nil,   175,   nil,   112,
   219,   nil,   nil,   nil,   nil,   nil,   nil,   241,   nil,   nil,
   nil,   nil,    66,   nil,   nil,   nil,   nil,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,   nil,   nil,   120,   nil,   nil,   nil,
   nil,   nil,   nil,   118,   nil,    89,   nil,   nil,   nil,   nil,
   345,   362,   nil,   445,   485,   326,   nil,   nil,   nil,   nil,
    39,    43,   nil,   521,    14,   nil,    90,   104,   150,   nil,
   113,   132,    -7,   nil,   nil,   nil,   nil,   nil,   nil,   nil,
   512,   nil,   nil,   nil,   403,   nil,   nil,   nil,   nil,   nil,
   466,   nil,   nil,   503,   nil,   nil,   nil,   nil,   nil,   424,
   nil,   nil,    17,   nil,   153,   nil,   nil,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,    -3,   nil,   nil,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,   nil,    49,   nil,   nil,   nil,    61,
    55,   547,   530,   nil,    20,   nil,   nil,   nil,   nil,   nil,
   nil,   nil,   nil,   nil,   555,   125,   125,   nil,   nil,   128,
   nil,   nil,   nil,   494,   nil,   563,   nil,    89,   nil,   nil,
   nil,   143,   539,   nil ]

racc_goto_table = [
    53,    64,    60,   103,   124,   143,    66,    61,    70,   160,
   157,   112,    96,    37,    14,   113,    96,    96,    25,   153,
    74,   152,   158,    76,    25,    73,    77,    25,   140,    79,
    25,    94,    32,    80,    81,    25,   114,    25,    25,   153,
    75,    82,    96,    84,   152,    25,    96,    55,   155,   nil,
   nil,   nil,   160,   nil,   nil,   nil,    99,    64,    60,   nil,
   105,   157,   101,   nil,   102,    96,    96,   nil,   139,    64,
   157,   nil,   nil,   nil,   166,   142,    28,   167,   nil,   157,
   nil,   163,    28,   nil,   nil,    28,   nil,   nil,    28,   nil,
   nil,   nil,    21,    28,   nil,    28,    28,   105,    21,   nil,
   nil,    21,   nil,    28,    21,   172,   105,   nil,    10,    21,
   nil,    21,    21,   nil,    10,   nil,   nil,    10,   nil,    21,
    10,   nil,   nil,   nil,     3,    10,   nil,    10,    10,   nil,
     3,   nil,   nil,     3,   nil,    10,     3,   164,    64,   nil,
     7,     3,   nil,     3,     3,   nil,     7,   nil,   nil,     7,
   nil,     3,     7,   nil,   nil,   nil,   nil,     7,   nil,     7,
     7,   nil,   nil,   nil,   nil,   nil,   nil,     7 ]

racc_goto_check = [
    22,    34,    24,    23,    16,    18,    19,    17,    20,    37,
    35,    21,    36,    41,     1,    32,    36,    36,     4,    28,
     1,    33,    29,     1,     4,    13,     1,     4,    14,     3,
     4,    25,    38,     1,     1,     4,    25,     4,     4,    28,
    39,     1,    36,    41,    33,     4,    36,    15,    21,   nil,
   nil,   nil,    37,   nil,   nil,   nil,    22,    34,    24,   nil,
    24,    35,    19,   nil,    20,    36,    36,   nil,    22,    34,
    35,   nil,   nil,   nil,    18,    17,     5,    16,   nil,    35,
   nil,    23,     5,   nil,   nil,     5,   nil,   nil,     5,   nil,
   nil,   nil,    11,     5,   nil,     5,     5,    24,    11,   nil,
   nil,    11,   nil,     5,    11,    23,    24,   nil,     8,    11,
   nil,    11,    11,   nil,     8,   nil,   nil,     8,   nil,    11,
     8,   nil,   nil,   nil,     6,     8,   nil,     8,     8,   nil,
     6,   nil,   nil,     6,   nil,     8,     6,    22,    34,   nil,
     7,     6,   nil,     6,     6,   nil,     7,   nil,   nil,     7,
   nil,     6,     7,   nil,   nil,   nil,   nil,     7,   nil,     7,
     7,   nil,   nil,   nil,   nil,   nil,   nil,     7 ]

racc_goto_pointer = [
   nil,    14,   nil,    12,    18,    76,   124,   140,   108,   nil,
   nil,    92,   nil,    20,   -45,    42,   -67,     2,   -68,     1,
     3,   -52,    -5,   -60,    -3,   -29,   nil,   nil,   -75,   -87,
   nil,   nil,   -49,   -69,    -4,   -93,   -48,  -115,    30,    32,
   nil,    11 ]

racc_goto_default = [
   nil,   nil,    17,    22,    69,    72,    54,    57,    59,    13,
    16,    67,    24,   nil,   nil,   nil,   nil,   nil,   nil,   nil,
   nil,   nil,   nil,   154,    91,   nil,    65,   109,    97,   111,
    89,   104,    90,    93,    95,   108,   110,   138,   nil,     4,
     8,   nil ]

racc_token_table = {
 false => 0,
 Object.new => 1,
 :EX_LOW => 2,
 :QUOTE => 3,
 :BAR => 4,
 :SLASH => 5,
 :BACK_SLASH => 6,
 :URL => 7,
 :OTHER => 8,
 :REF_OPEN => 9,
 :FOOTNOTE_OPEN => 10,
 :FOOTNOTE_CLOSE => 11,
 :EX_HIGH => 12,
 :EM_OPEN => 13,
 :EM_CLOSE => 14,
 :CODE_OPEN => 15,
 :CODE_CLOSE => 16,
 :VAR_OPEN => 17,
 :VAR_CLOSE => 18,
 :KBD_OPEN => 19,
 :KBD_CLOSE => 20,
 :INDEX_OPEN => 21,
 :INDEX_CLOSE => 22,
 :REF_CLOSE => 23,
 :VERB_OPEN => 24,
 :VERB_CLOSE => 25 }

racc_nt_base = 26

Racc_arg = [
 racc_action_table,
 racc_action_check,
 racc_action_default,
 racc_action_pointer,
 racc_goto_table,
 racc_goto_check,
 racc_goto_default,
 racc_goto_pointer,
 racc_nt_base,
 racc_reduce_table,
 racc_token_table,
 racc_shift_n,
 racc_reduce_n ]

Racc_debug_parser = false

##### racc system variables end #####


 # reduce 0 omitted

 # reduce 1 omitted

 module_eval( <<'.,.,', 'rd/rdinlineparser.ry', 13 )
  def _reduce_2( val, _values, result )
 result.push(val[1])
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdinlineparser.ry', 14 )
  def _reduce_3( val, _values, result )
 result = val
   result
  end
.,.,

 # reduce 4 omitted

 # reduce 5 omitted

 # reduce 6 omitted

 # reduce 7 omitted

 # reduce 8 omitted

 # reduce 9 omitted

 # reduce 10 omitted

 # reduce 11 omitted

 # reduce 12 omitted

 module_eval( <<'.,.,', 'rd/rdinlineparser.ry', 28 )
  def _reduce_13( val, _values, result )
				result = Emphasis.new(val[1])
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdinlineparser.ry', 31 )
  def _reduce_14( val, _values, result )
				result = Code.new(val[1])
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdinlineparser.ry', 34 )
  def _reduce_15( val, _values, result )
				result = Var.new(val[1])
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdinlineparser.ry', 37 )
  def _reduce_16( val, _values, result )
				result = Keyboard.new(val[1])
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdinlineparser.ry', 40 )
  def _reduce_17( val, _values, result )
				result = Index.new(val[1])
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdinlineparser.ry', 47 )
  def _reduce_18( val, _values, result )
 result = Reference.new(val[2], val[1])
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdinlineparser.ry', 49 )
  def _reduce_19( val, _values, result )
 result = Reference.new(val[1])
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdinlineparser.ry', 52 )
  def _reduce_20( val, _values, result )
 result = Reference::URL.new(val[1])
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdinlineparser.ry', 54 )
  def _reduce_21( val, _values, result )
 result = Reference::RDLabel.new(val[1], val[0])
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdinlineparser.ry', 56 )
  def _reduce_22( val, _values, result )
 result = Reference::RDLabel.new(val[0])
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdinlineparser.ry', 57 )
  def _reduce_23( val, _values, result )
 result = Reference::RDLabel.new(nil, val[0])
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdinlineparser.ry', 59 )
  def _reduce_24( val, _values, result )
 result = Reference::URL.new(val[1])
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdinlineparser.ry', 61 )
  def _reduce_25( val, _values, result )
 result = Reference::RDLabel.new(val[1], val[0])
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdinlineparser.ry', 63 )
  def _reduce_26( val, _values, result )
 result = Reference::RDLabel.new(val[0])
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdinlineparser.ry', 64 )
  def _reduce_27( val, _values, result )
 result = Reference::RDLabel.new(nil, val[0])
   result
  end
.,.,

 # reduce 28 omitted

 module_eval( <<'.,.,', 'rd/rdinlineparser.ry', 68 )
  def _reduce_29( val, _values, result )
 result = val[1]
   result
  end
.,.,

 # reduce 30 omitted

 module_eval( <<'.,.,', 'rd/rdinlineparser.ry', 73 )
  def _reduce_31( val, _values, result )
 result = val[1]
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdinlineparser.ry', 78 )
  def _reduce_32( val, _values, result )
 result = [StringElement.new(val[0])]
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdinlineparser.ry', 80 )
  def _reduce_33( val, _values, result )
 result = [StringElement.new(val[1])]
   result
  end
.,.,

 # reduce 34 omitted

 module_eval( <<'.,.,', 'rd/rdinlineparser.ry', 86 )
  def _reduce_35( val, _values, result )
 result = val[1]
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdinlineparser.ry', 90 )
  def _reduce_36( val, _values, result )
 result = val[1].unshift(val[0])
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdinlineparser.ry', 92 )
  def _reduce_37( val, _values, result )
 result = val[1].unshift(val[0])
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdinlineparser.ry', 94 )
  def _reduce_38( val, _values, result )
 result = val
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdinlineparser.ry', 95 )
  def _reduce_39( val, _values, result )
 result = val
   result
  end
.,.,

 # reduce 40 omitted

 module_eval( <<'.,.,', 'rd/rdinlineparser.ry', 100 )
  def _reduce_41( val, _values, result )
 result.push(val[1])
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdinlineparser.ry', 101 )
  def _reduce_42( val, _values, result )
 result = val
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdinlineparser.ry', 104 )
  def _reduce_43( val, _values, result )
 result.push(val[1])
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdinlineparser.ry', 105 )
  def _reduce_44( val, _values, result )
 result = val
   result
  end
.,.,

 # reduce 45 omitted

 # reduce 46 omitted

 # reduce 47 omitted

 # reduce 48 omitted

 # reduce 49 omitted

 # reduce 50 omitted

 # reduce 51 omitted

 # reduce 52 omitted

 # reduce 53 omitted

 # reduce 54 omitted

 module_eval( <<'.,.,', 'rd/rdinlineparser.ry', 122 )
  def _reduce_55( val, _values, result )
 result = StringElement.new(val[0])
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdinlineparser.ry', 125 )
  def _reduce_56( val, _values, result )
 result = StringElement.new(val[0])
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdinlineparser.ry', 128 )
  def _reduce_57( val, _values, result )
 result = StringElement.new(val[0])
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdinlineparser.ry', 132 )
  def _reduce_58( val, _values, result )
 result << val[1]
   result
  end
.,.,

 # reduce 59 omitted

 module_eval( <<'.,.,', 'rd/rdinlineparser.ry', 138 )
  def _reduce_60( val, _values, result )
 result << val[1]
   result
  end
.,.,

 # reduce 61 omitted

 module_eval( <<'.,.,', 'rd/rdinlineparser.ry', 142 )
  def _reduce_62( val, _values, result )
 result << val[1]
   result
  end
.,.,

 # reduce 63 omitted

 # reduce 64 omitted

 # reduce 65 omitted

 # reduce 66 omitted

 # reduce 67 omitted

 # reduce 68 omitted

 # reduce 69 omitted

 # reduce 70 omitted

 # reduce 71 omitted

 # reduce 72 omitted

 # reduce 73 omitted

 # reduce 74 omitted

 # reduce 75 omitted

 module_eval( <<'.,.,', 'rd/rdinlineparser.ry', 165 )
  def _reduce_76( val, _values, result )
 result << val[1]
   result
  end
.,.,

 # reduce 77 omitted

 # reduce 78 omitted

 # reduce 79 omitted

 # reduce 80 omitted

 # reduce 81 omitted

 # reduce 82 omitted

 # reduce 83 omitted

 # reduce 84 omitted

 # reduce 85 omitted

 # reduce 86 omitted

 # reduce 87 omitted

 # reduce 88 omitted

 # reduce 89 omitted

 # reduce 90 omitted

 # reduce 91 omitted

 # reduce 92 omitted

 # reduce 93 omitted

 # reduce 94 omitted

 # reduce 95 omitted

 # reduce 96 omitted

 # reduce 97 omitted

 # reduce 98 omitted

 module_eval( <<'.,.,', 'rd/rdinlineparser.ry', 196 )
  def _reduce_99( val, _values, result )
				result = Footnote.new(val[1])
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdinlineparser.ry', 199 )
  def _reduce_100( val, _values, result )
				result = Verb.new(val[1])
   result
  end
.,.,

 # reduce 101 omitted

 # reduce 102 omitted

 # reduce 103 omitted

 # reduce 104 omitted

 # reduce 105 omitted

 # reduce 106 omitted

 module_eval( <<'.,.,', 'rd/rdinlineparser.ry', 213 )
  def _reduce_107( val, _values, result )
 result << val[1]
   result
  end
.,.,

 # reduce 108 omitted

 module_eval( <<'.,.,', 'rd/rdinlineparser.ry', 218 )
  def _reduce_109( val, _values, result )
 result = StringElement.new(val[0])
   result
  end
.,.,

 # reduce 110 omitted

 # reduce 111 omitted

 # reduce 112 omitted

 # reduce 113 omitted

 # reduce 114 omitted

 # reduce 115 omitted

 # reduce 116 omitted

 # reduce 117 omitted

 # reduce 118 omitted

 # reduce 119 omitted

 # reduce 120 omitted

 # reduce 121 omitted

 # reduce 122 omitted

 # reduce 123 omitted

 # reduce 124 omitted

 # reduce 125 omitted

 # reduce 126 omitted

 # reduce 127 omitted

 # reduce 128 omitted

 module_eval( <<'.,.,', 'rd/rdinlineparser.ry', 241 )
  def _reduce_129( val, _values, result )
 result = val[1]
   result
  end
.,.,

 module_eval( <<'.,.,', 'rd/rdinlineparser.ry', 242 )
  def _reduce_130( val, _values, result )
 result = val[1]
   result
  end
.,.,

 # reduce 131 omitted

 module_eval( <<'.,.,', 'rd/rdinlineparser.ry', 245 )
  def _reduce_132( val, _values, result )
 result << val[1]
   result
  end
.,.,

 # reduce 133 omitted

end
end # end of module RD

