#!/usr/local/bin/ruby
# rdtoolconf.rb - create Makefile for rdtool.
# $Id: rdtoolconf.rb,v 1.5 2000/06/24 16:44:25 toshirok Exp $

require 'mkmf'
require 'rbconfig'
require 'amstd/rbparams'

print "creating Makefile\n"
STDOUT.flush

$bindir = RubyParams::BINDIR
$siterubydir = RubyParams::SITE_RB
$rddir = CONFIG["datadir"] + "/ruby/rd"
$racc = "racc"

mfile = open("Makefile", "w")
mfile.print  <<"EOM"
#
# RDtool makefile

BIN_DIR = #{$bindir}
SITE_RUBY = #{$siterubydir}
RD_DIR = #{$rddir}

RUBY = #{CONFIG["ruby_install_name"]}
RUBY_OPT = -I.
RACC = #{$racc}
# RACC_OPT = -gv

RD_LIBS = rd/rdfmt.rb \\
          rd/rdvisitor.rb \\
          rd/rd2html-lib.rb \\
          rd/rd2html-opt.rb \\
          rd/rd2man-lib.rb \\
          rd/rd2rdo-lib.rb \\
          rd/filter.rb \\
          rd/dot.rd2rc

PARSERS = rd/rdblockparser.tab.rb \\
	  rd/rdinlineparser.tab.rb 

PARSERS_NONEXT = missing/rdblockparser.tab.rb \\
		 missing/rdinlineparser.tab.rb

RD_DOCS = README.rd
HTML_DOCS = README.html
MADE_FILE = rd/rdblockparser.tab.rb \\
            rd/rdinlineparser.tab.rb \\
            rd/rdblockparser.output \\
            rd/rdinlineparser.output \\
            README.html

all : rd2 ${RD_LIBS} ${PARSERS} ${HTML_DOCS}

clean :
	rm -f ${MADE_FILE}
	rm -f ./Makefile

install : rd2 ${RD_LIBS} ${PARSERS}
	install -c -m 755 rd2 ${BIN_DIR}
	install -d ${SITE_RUBY}/rd
	install -c -m 644 ${RD_LIBS} ${PARSERS} ${SITE_RUBY}/rd/

install-nonext : rd2 ${RD_LIBS} ${PARSERS_NONEXT}
	install -c -m 755 rd2 ${BIN_DIR}
	install -d ${SITE_RUBY}/rd
	install -c -m 644 ${RD_LIBS} ${PARSERS_NONEXT} ${SITE_RUBY}/rd/
	install -c -m 644 missing/strscan.rb ${SITE_RUBY}/

install-rmi2html : rmi2html.rb
	install -c -m 755 rmi2html.rb ${BIN_DIR}
	install -c -m 644 rd/rd2rmi-lib.rb ${SITE_RUBY}/rd/

dist :
	${RACC} ${RACC_OPT} -E -o missing/rdblockparser.tab.rb rd/rdblockparser.ry
	${RACC} ${RACC_OPT} -E -o missing/rdinlineparser.tab.rb rd/rdinlineparser.ry

.SUFFIXES : .html .rd .tab.rb .ry
.ry.tab.rb :
	${RACC} ${RACC_OPT} $<

.rd.html :
	${RUBY} ${RUBY_OPT} rd2 -r rd/rd2html-lib.rb $< > $@
EOM
